Summary:	An iterative solver for sparse symmetric equations
Name:		minres
Version:	20071017
Release:	2
License:	OSI Common Public License
Group:		Libraries
Source:		http://www.stanford.edu/group/SOL/software/minres/f90/minresf90.zip
Source1:	minresWrapper.f90
Source2:	test.c
Patch:		minresModule.diff
URL:		http://www.stanford.edu/group/SOL/software/minres.html
BuildRoot:	/var/tmp/%{name}-%{version}-root
%ifos linux
BuildArch:	i386 x86_64
BuildRequires:  gcc gcc-gfortran
%else
AutoReqProv:	no
BuildArch:	x86_64
%endif
Prefix:		/usr

%description
MINRES solves symmetric systems Ax = b or min ||Ax - b||_2, where the matrix A
may be indefinite and/or singular.

This package provides a wrapper function minresWrapper to the Fortran 90 module
of MINRES which casts logical arguments to integer type.

%prep
%setup -q -n minresf90 -c
%patch -p0
cp -a %{SOURCE1} %{SOURCE2} .

%build
if test -z "$FC"; then
    # Check gfortran
    if gfortran -v >/dev/null 2>&1; then
	ver=`env LANG=C gfortran -v 2>&1 | tail -1 \
			| grep version | awk '{print $3}'`
	ver0=`echo $ver | awk -F. '{print $1}'`
	ver1=`echo $ver | awk -F. '{print $2}'`
	if test "$ver0" -gt "4"; then
	    FC="gfortran"
	elif test "$ver0" -ge "4" -a "$ver1" -ge "4"; then
	    FC="gfortran"
	fi
    fi
    # Check ifort
    if test -z "$FC"; then
	if ifort -v >/dev/null 2>&1; then
	    FC="ifort"
	fi
    fi
    # Final check
    if test -z "$FC"; then
	echo "########## Please set FC for the Fortran 90 compiler. ##########"
	exit 1
    fi
fi
test -z "$FFLAGS" && FFLAGS="-O3 -g -Wall -fpic"
$FC -c $FFLAGS minresDataModule.f90
$FC -c $FFLAGS minresModule.f90
$FC -c $FFLAGS minresWrapper.f90
%ifnos darwin
  $FC -shared -o libminres.so minresDataModule.o minresModule.o minresWrapper.o
  chmod a+r libminres.so minresdatamodule.mod minresmodule.mod
%else
  ${FC} -dynamiclib -dylinker_install_name %{_libdir}/libminres.dylib \
	-o libminres.dylib minresDataModule.o minresModule.o minresWrapper.o
  chmod a+r libminres.dylib minresdatamodule.mod minresmodule.mod
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{%{_libdir},%{_includedir}/%{name}}
%ifnos darwin
  /bin/cp -a libminres.so $RPM_BUILD_ROOT/%{_libdir}/.
%else
  /bin/cp -a libminres.dylib $RPM_BUILD_ROOT/%{_libdir}/.
%endif
/bin/cp -a minresdatamodule.mod minresmodule.mod \
		$RPM_BUILD_ROOT/%{_includedir}/%{name}/.

%clean
rm -fr $RPM_BUILD_ROOT

%post
if test -x /sbin/ldconfig; then
    /sbin/ldconfig
fi

%postun
if test -x /sbin/ldconfig; then
    /sbin/ldconfig
fi

%files
%defattr(644,root,root,755)
%doc test.c README MINRES.txt
%{_libdir}/libminres.*
%{_includedir}/%{name}/*

%changelog
