!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Wrapper function using integer for 'checkA' and 'precon'
subroutine minresWrapper( n, Aprod, Msolve, b, shift, icheckA, iprecon, &
                          x, itnlim, nout, rtol,                        &
                          istop, itn, Anorm, Acond, rnorm, Arnorm,      &
                          ynorm, dot, check_res )
    use       minresDataModule
    use       minresModule
    integer,  intent(in)    :: n, itnlim, nout
    integer,  intent(in)    :: icheckA, iprecon
    real(dp), intent(in)    :: b(n)
    real(dp), intent(in)    :: shift, rtol
    real(dp), intent(out)   :: x(n)
    integer,  intent(out)   :: istop, itn
    real(dp), intent(out)   :: Anorm, Acond, rnorm, Arnorm, ynorm

    interface
       subroutine Aprod (n,x,y)  ! y := A*x
         use minresDataModule
         integer,  intent(in)  :: n
         real(dp), intent(in)  :: x(n)
         real(dp), intent(out) :: y(n)
       end subroutine Aprod

       subroutine Msolve(n,x,y) ! Solve M*y = x
         use minresDataModule
         integer,  intent(in)  :: n
         real(dp), intent(in)  :: x(n)
         real(dp), intent(out) :: y(n)
       end subroutine Msolve

       real(dp) function dot(x, y)
         use minresDataModule
         real(dp), intent(in)  :: x(*)
         real(dp), intent(in)  :: y(*)
       end function dot

       integer function check_res(n, x, rnorm, itn)
         use  minresDataModule
         integer,  intent(in)    :: n
         real(dp), intent(in)    :: x(*)
         real(dp), intent(in)    :: rnorm
         integer,  intent(in)    :: itn
       end function check_res
    end interface
    ! local variables
    logical checkA, precon

    if (icheckA .ne. 0) then
      checkA = .true.
    else
      checkA = .false.
    endif

    if (iprecon .ne. 0) then
      precon = .true.
    else
      precon = .false.
    endif
    call MINRES( n, Aprod, Msolve, b, shift, checkA, precon,     &
                 x, itnlim, nout, rtol,                          &
                 istop, itn, Anorm, Acond, rnorm, Arnorm, ynorm, &
                 dot, check_res )
    return
end subroutine minresWrapper
